
/*
 * $Id: polyErrors.cc,v 1.2 1999/04/15 20:36:01 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "polygraph.h"

#include <errno.h>
#include <string.h>

#include "polyErrors.h"

/* PolyErrMgr */

PolyErrMgr::PolyErrMgr(): ErrorMgr(errEnd-1) {
	theExpls.stretch(errEnd);

	theExpls[errForeignReq]   = "foreign request";
	theExpls[errForeignRep]   = "foreign reply";
	theExpls[errPrematureEof] = "premature end of transmission";
	theExpls[errNoCLen]       = "no Content-Length header";
	theExpls[errHugeHdr]      = "HTTP header is too big";
	theExpls[errUnchbHit]     = "hit on uncachable object";
	theExpls[err1UseHit]      = "hit on first request to an object";
	theExpls[errZeroFDLimit]  = "zero filedescriptor limit?!";
	theExpls[errChbChange]    = "cachability status changed";
	theExpls[errFalseHit]     = "false hit";
	theExpls[errServerGone]   = "server had to terminate";
	theExpls[errLogBufFull]   = "log buffer is full";
	theExpls[errBadRPort]        = "cannot get a valid remote port number";
	theExpls[errRPortOutOfRange] = "remote port is too high";
	theExpls[errRPortUsedTwice]  = "same remote port for two active conns";
	

	// check that all are defined
	for (int i = errStart+1; i < errEnd; ++i)
		Assert(theExpls[i]);
}

const char *PolyErrMgr::explStr(int e) const {
	if (e > errStart && e < errEnd)
		return theExpls[e];
	else
		return ErrorMgr::explStr(e);
}
